' DocFname.VBS V1.04 (C) yoshioka.teruo@nifty.com, 2005-02-08
' DocFname.VBS changes the Office file name to "yyyymmdd title".
' Usage: Start DocFname.VBS files...

Option Explicit
Dim fso
Dim arg
Dim Ext
Dim Book
Dim Prop
Dim Title
Dim ModDate
Dim File
Dim ans
Dim n

Set fso=CreateObject("Scripting.FileSystemObject")

For Each arg In WScript.Arguments
  Ext=fso.GetExtensionName(arg)
  Select Case Ucase(Ext)
    Case "DOC","XLS","PPT"
    Case Else
      WScript.Echo "Unknown Extension Name : ",arg
      WScript.Quit
  End Select

  Set File=fso.GetFile(arg)
  ModDate=File.DateLastModified

  Set Book=GetObject(File.Path)
  Title=Book.BuiltinDocumentProperties("Title")
  Set Prop=Book.BuiltinDocumentProperties(12)
  If VarType(Prop)=vbDate Then
    ModDate=Prop.Value
  End If
  Set Prop=Nothing
  Set Book=Nothing

  If Title<>"" Then
    Title=Replace(Title,"\","")
    Title=Replace(Title,"/","^")
    Title=Replace(Title,":","F")
    Title=Replace(Title,"*","")
    Title=Replace(Title,"?","H")
    Title=Replace(Title,"""","h")
    Title=Replace(Title,"<","")
    Title=Replace(Title,">","")
    Title=Replace(Title,"|","b")
  End If

  ModDate=CStr(Year(ModDate)*10000 + Month(ModDate)*100 + Day(ModDate))&Space(1)
'  ModDate=""
  ans=ModDate & Title & "." & Ext
  ans=InputBox("Enter New Name",File.Name,ans)
  n=1
  Do While ans<>""
    Call Rename(File,ans)
    If Err=0 Then
      ans=""
    ElseIf Err=58 Then
      n=n+1
      ans=ModDate & Title & " " & n & "." & Ext
      ans=InputBox(Err.Number & ":" & Err.Description & "Re-Enter New Name",File.Name,ans)
    Else
      ans=InputBox(Err.Number & ":" & Err.Description & "Re-Enter New Name",File.Name,ans)
    End If
  Loop
Next

WScript.Quit

Sub Rename(File,name)
On Error Resume Next
File.Name=name
End Sub
